function main(){
	var mapping=new Array();

	mapping.SwAxisGeneric=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "swNumberOfAxisPoints");
	};
	
	mapping.SwClass=
	function(element){
		handleDeleteStereotype(element, "SwClass");
	};
	
	mapping.SwVariable=
	function(element){
		handleDeleteStereotype(element, "SwVariable");
		handleDeleteTag(element, "mixedContentIndex");
	};
	
	mapping.SwVariableRefMsr=
	function(element){
		handleDeleteStereotype(element, "SwVariableRefMsr");
	};
	
	mapping.l_swVariable=
	function(element){
		handleDeleteStereotype(element, "l_swVariable");
	};
	
	mapping.SwServiceProps=
	function(element){
		handleDeleteTag(element, "swServiceRecursive");
	};
	
	mapping.UnitSpec=
	function(element){
		handleDeleteTag(element, "category");
		handleDeleteStereotypeFromAggregates(element, "AdminData");
	};
	
	mapping.SwCalprm=
	function(element){
		handleDeleteStereotype(element, "SwCalprm");
	};
	
	mapping.SwCalprmRef=
	function(element){
		handleDeleteStereotype(element, "SwCalprmRef");
	};

	mapping.SwClassInstance=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "SwArraysize");
		handleDeleteStereotypeFromAggregates(element, "l_swClass");
		handleDeleteStereotypeFromAggregates(element, "l_swClassAttrImpl");
	};
	
	mapping.l_swCalprmAxisIndividualAxis=
	function(element){
		handleDeleteStereotype(element, "l_swCalprmAxisIndividualAxis");
	};
	
	mapping.l_swCalprm=
	function(element){
		handleDeleteStereotype(element, "l_swCalprm");
	};
	
	mapping.SwCalprmValueAxisLabels=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "label");
	};

	mapping.SwAxisIndividual=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "SwBitRepresentation");
	};
	
	mapping.SwAxisGrouped=
	function(element){
		handleDeleteTag(element, "swAxisIndex");
	};
	
	mapping.ByteOrder=
	function(element){
		handleDeleteTag(element, "type");
	};
	
	mapping.SwConstrObjects=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "l_compuMethod");
		handleDeleteStereotypeFromAggregates(element, "l_swCalprm");
		//handleDeleteStereotypeFromAggregates(element, "l_swVariable"); see rule on l_swVariable
	}
	
	mapping.SwDataDefProps=
	function(element){
		handleDeleteTag(element, "swAliasName");
		handleDeleteTag(element, "swCalprmNoEffectValue");
		handleDeleteTag(element, "swIntendedResolution");
		handleDeleteTag(element, "swInterpolationMethod");
		handleDeleteTag(element, "swIsVirtual");
		handleDeleteTag(element, "swVarNotAvlValue");
		
		handleDeleteStereotypeFromAggregates(element, "swCalprmTarget");
		handleDeleteStereotypeFromAggregates(element, "SwCalprmValueAxisLabels");
		handleDeleteStereotypeFromAggregates(element, "SwComparisonVariables");
		handleDeleteStereotypeFromAggregates(element, "SwSemaphore");
		
		handleDeleteStereotypeFromAggregates(element, "l_swClass");
		handleDeleteStereotypeFromAggregates(element, "l_swClassAttrImpl");
		handleDeleteStereotypeFromAggregates(element, "l_swService");
	};
	
	mapping.CompuMethod=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "internalConstrs1");
		handleDeleteStereotypeFromAggregates(element, "physConstrs1");
		handleDeleteStereotypeFromAggregates(element, "l_dataConstr");
		handleDeleteTag(element, "compuIdentity");
		handleDeleteTag(element, "mixedContentIndex");
	};
	
	mapping.CompuScale=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "compuInverseValue");
	};
	
	mapping.CompuScaleGenericMath=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "CompuGenericMath");
	};
	
	mapping.Modification=
	function(element){
		handleDeleteTag(element, "type");
	};
	
	mapping.XrefTarget=
	function(element){
		handleDeleteTag(element, "mixedContentIndex");
		handleDeleteStereotypeFromAggregates(element, "longName1");
	};
	
	mapping.PhysConstrs=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "SwRelatedConstrs");
	};
	
	mapping.EType=
	function(element){
		handleDeleteTag(element, "color");
		handleDeleteTag(element, "font");
		handleDeleteTag(element, "type");
		handleDeleteTag(element, "mixedContentIndex");
	};
	
	mapping.L1=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
		handleDeleteStereotypeFromAggregates(element, "Br");
		handleDeleteStereotypeFromAggregates(element, "EType");
		handleDeleteStereotypeFromAggregates(element, "Ft");
		handleDeleteStereotypeFromAggregates(element, "Ie");
		handleDeleteStereotypeFromAggregates(element, "Std");
		handleDeleteStereotypeFromAggregates(element, "Tt");
		handleDeleteStereotypeFromAggregates(element, "Xdoc");
		handleDeleteStereotypeFromAggregates(element, "Xref");
		handleDeleteStereotypeFromAggregates(element, "XrefTarget");
	};
	
	mapping.SIData1=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
		handleDeleteStereotypeFromAggregates(element, "Br");
		handleDeleteStereotypeFromAggregates(element, "EType");
		handleDeleteStereotypeFromAggregates(element, "Ft");
		handleDeleteStereotypeFromAggregates(element, "Ie");
		handleDeleteStereotypeFromAggregates(element, "Std");
		handleDeleteStereotypeFromAggregates(element, "Tt");
		handleDeleteStereotypeFromAggregates(element, "Xdoc");
		handleDeleteStereotypeFromAggregates(element, "Xref");
		handleDeleteStereotypeFromAggregates(element, "XrefTarget");
	};
	
	mapping.L2=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
		handleDeleteStereotypeFromAggregates(element, "EType");
		handleDeleteStereotypeFromAggregates(element, "Ft");
		handleDeleteStereotypeFromAggregates(element, "Ie");
		handleDeleteStereotypeFromAggregates(element, "Tt");
		handleDeleteStereotypeFromAggregates(element, "Xref");
		handleDeleteStereotypeFromAggregates(element, "XrefTarget");
	};
	
	mapping.SIData2=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
		handleDeleteStereotypeFromAggregates(element, "EType");
		handleDeleteStereotypeFromAggregates(element, "Ft");
		handleDeleteStereotypeFromAggregates(element, "Ie");
		handleDeleteStereotypeFromAggregates(element, "Tt");
		handleDeleteStereotypeFromAggregates(element, "Xref");
		handleDeleteStereotypeFromAggregates(element, "XrefTarget");
	};
	
	mapping.L3=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
	};
	
	mapping.SIData3=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
	};
	
	mapping.SIData3p=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
	};
	
	mapping.L4=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
		handleDeleteStereotypeFromAggregates(element, "EType");
		handleDeleteStereotypeFromAggregates(element, "Ie");
		handleDeleteStereotypeFromAggregates(element, "Tt");
	};
	
	mapping.SIData4=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
		handleDeleteStereotypeFromAggregates(element, "EType");
		handleDeleteStereotypeFromAggregates(element, "Ie");
		handleDeleteStereotypeFromAggregates(element, "Tt");
	};
	
	mapping.L5=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "EType");
		handleDeleteStereotypeFromAggregates(element, "Br");
		handleDeleteStereotypeFromAggregates(element, "Xref");
	};
	
	mapping.SIData5=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "EType");
		handleDeleteStereotypeFromAggregates(element, "Br");
		handleDeleteStereotypeFromAggregates(element, "Xref");
	};
	
	mapping.longName1=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
	};
	
	mapping.displayName=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
	};
	
	mapping.Std=
	function(element){
		handleDeleteTag(element, "date");
		handleDeleteTag(element, "mixedContentIndex");
		handleDeleteTag(element, "position");
		handleDeleteTag(element, "state");
		handleDeleteTag(element, "subtitle");
		handleDeleteStereotypeFromAggregates(element, "Url");
		handleDeleteStereotypeFromAggregates(element, "longName1");
	};
	
	mapping.Xdoc=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "Url");
		handleDeleteStereotypeFromAggregates(element, "longName1");
	};
	
	mapping.Ie=
	function(element){
		handleDeleteTag(element, "type");
		handleDeleteTag(element, "mixedContentIndex");
		handleDeleteStereotypeFromAggregates(element, "sub");
		handleDeleteStereotypeFromAggregates(element, "sup");
	};
	
	mapping.InternalConstrs=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "SwRelatedConstrs");
	};
	
	mapping.Br=
	function(element){
		handleDeleteTag(element, "mixedContentIndex");
	};
	
	mapping.DataConstrRule=
	function(element){
		handleDeleteTag(element, "constrLevel");
	};
	
	mapping.DataConstr=
	function(element){
		//handleDeleteStereotypeFromAggregates(element, "SwConstrObjects")
	};
	
	mapping.Ft=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "EType")
		handleDeleteStereotypeFromAggregates(element, "Tt");
		handleDeleteTag(element, "mixedContentIndex");
	};
	
	mapping.CompanyRevisionInfo=
	function(element){
		handleDeleteStereotype(element, "CompanyRevisionInfo");
	};
	
	mapping.CompanySpecificInfo=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "Sdg");
	};
	
	mapping.FlexrayCluster=
	function(element){
		handleRenameTag(element, "OffsetCorrectionStart", "offsetCorrectionStart");
		handleRenameTag(element, "syncNodeMax", "syncFrameIDCountMax");
		handleRenameTag(element, "wakeUpSymbolRxIdle", "wakeupRxIdle");
		handleRenameTag(element, "wakeUpSymbolRxLow", "wakeupRxLow");
		handleRenameTag(element, "wakeUpSymbolRxWindow", "wakeupRxWindow");
		handleRenameTag(element, "wakeUpSymbolTxLow", "wakeupTxActive");
		handleRenameTag(element, "wakeUpSymbolTxIdle", "wakeupTxIdle");
	};
	
	mapping.ProgCode=
	function(element){
		handleDeleteTag(element, "codeFile");
		handleDeleteTag(element, "encryption");
		handleDeleteTag(element, "entrypoint");
		handleDeleteTag(element, "langSubset");
		handleDeleteTag(element, "programLang");
		handleDeleteTag(element, "revision");
		handleDeleteTag(element, "syntax");
		handleDeleteTag(element, "usedLibs");
	};
	
	mapping.SwRelatedConstrs=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "SwDataDependency");
	};
	
	mapping.SwDataDependency=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "desc");
	};
	
	mapping.SwPointer=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "desc");
	};
	
	mapping.SwTextProps=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "l_baseType");
	};
	
	mapping.SwAxisIndividual=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "SwBitRepresentation");
	};
	
	mapping.SwRecordLayoutV=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "desc");
		handleDeleteStereotypeFromAggregates(element, "l_swGenericAxisParamType");
	};
	
	mapping.SwServiceImpl=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "swServiceArg");
		handleDeleteStereotypeFromAggregates(element, "SwServiceProps");
		handleDeleteStereotypeFromAggregates(element, "swServiceReturn");
		handleDeleteStereotypeFromAggregates(element, "l_swServicePrototype");
	}
	
	mapping.SwCalprmPrototype=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "SwArraysize");
	}
	
	mapping.SwRecordLayoutGroup=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "desc");
		handleDeleteStereotypeFromAggregates(element, "l_swGenericAxisParamType");
	};
	
	mapping.SwGenericAxisParamType=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "desc");
		handleDeleteStereotypeFromAggregates(element, "l_swGenericAxisParamType");
	};
	
	mapping.SwServiceAccessedElementSet=
	function(element){
		handleDeleteStereotypeFromAggregates(element, "desc");
	};
	
	mapping.ProgCode=
	function(element){
		handleDeleteTag(element, "swServiceRecursive");
	}
	
	mapping.FlexrayCommunicationController=
	function(element){
		handleRenameTag(element, "singleSlotEnabled", "keySlotOnlyEnabled");
		handleDeleteTag(element, "maxDrift");
	};
	
	mapping.FlexRayTpChannel=
	function(element){
		handleRenameStereotype(element, "FlexRayTpChannel", "FlexrayTpChannel");
	};
	
	mapping.FlexRayTpConnection=
	function(element){
		migrateTpChannelElement(element, "FlexrayTpNode", "flexrayTpNode", element.getOwner().getOwner());
	};
	
	mapping.LinTpChannel=
	function(element){
		migrateTpChannelElement(element, "CanTpNode", "canTpNode", element.getOwner());
	};
	
	mapping.CanTpConnectionChannel=
	function(element){
		migrateTpChannelElement(element, "LinTpNode", "linTpNode", element.getOwner());
	};
		
	mapping.Xfile=
	function(element){
		var owner = element.getOwner().getOwner();
		if(hasStereotypeApplied(owner, "Code")){
			changeMetaClassAndStereotype(element, "Comment", "XfileSo");
		}
		handleChangeGeneralizationTarget(element);
	};
	
	mapping.NewIsEqual=
	function(element){
		handleRenameStereotype(element, "NewIsEqual", getPropertyValueOfElement(element, "NewIsEqual_DataFilter"));
	};
		
	mapping.NewIsLess=
	function(element){
		handleRenameStereotype(element, "NewIsLess", getPropertyValueOfElement(element, "NewIsLess_DataFilter"));
	};
	
	mapping.NewIsDifferent=
	function(element){
		handleRenameStereotype(element, "NewIsDifferent", getPropertyValueOfElement(element, "NewIsDifferent_DataFilter"));
	};
		
	mapping.NewIsGreaterOrEqual=
	function(element){
		handleRenameStereotype(element, "NewIsGreaterOrEqual", getPropertyValueOfElement(element, "NewIsGreaterOrEqual_DataFilter"));
	};
		
	mapping.NewIsGreater=
	function(element){
		handleRenameStereotype(element, "NewIsGreater", getPropertyValueOfElement(element, "NewIsGreater_DataFilter"));
	};
		
	mapping.NewIsLessOrEqual=
	function(element){
		handleRenameStereotype(element, "NewIsLessOrEqual", getPropertyValueOfElement(element, "NewIsLessOrEqual_DataFilter"));
	};

		
	return mapping;
}

migrateTpChannelElement = function(element, tpNodeStereotype, tpNodeName, owner){
	var dependencies = element.getDependencies();
	var stCount = dependencies.getCount();
	for (var i = 1; i <= stCount; i++) {
		try{
			var dependency = dependencies.getItem(i);
			if(dependency!=null && hasStereotypeApplied(dependency, "l_source")){
				if(owner!=null){
					var flexraytpnodeSource = createElementOn(owner, "Comment", tpNodeStereotype, tpNodeName+"Source");
					var lconnectorSource = createElementOn(flexraytpnodeSource, "Dependency", "l_connector", "");
					var communicationConnectorSource = dependency.getDependsOn();
					lconnectorSource.setDependsOn(communicationConnectorSource);
					dependency.setDependsOn(flexraytpnodeSource);
					
					var tpAddresstag = getTag(communicationConnectorSource, "tpAddress");
					if(tpAddresstag!=null){
						var tpAddresstagValue = tpAddresstag.getValue();
						if(tpAddresstagValue!=null){
							var tpAddressSource = getOrCreateElementOn(owner, "Comment", "TpAddress", "tpAddressSource_"+communicationConnectorSource.getName());
							setTagValue(tpAddressSource, "tpAddress", tpAddresstagValue);
							var ltpSource = createElementOn(flexraytpnodeSource, "Dependency", "l_connector", "");
							ltpSource.setDependsOn(tpAddressSource);
						}
					}
				}
			}
			else if(dependency!=null && hasStereotypeApplied(dependency, "l_target")){
				if(owner!=null){
					var flexraytpnodeTarget = createElementOn(owner, "Comment", tpNodeStereotype, tpNodeName+"Target");
					var lconnectorTarget = createElementOn(flexraytpnodeTarget, "Dependency", "l_connector", "");
					var communicationConnectorTarget = dependency.getDependsOn();
					lconnectorTarget.setDependsOn(dependency.getDependsOn());
					dependency.setDependsOn(flexraytpnodeTarget);
					
					var tpAddresstag = getTag(communicationConnectorTarget, "tpAddress");
					if(tpAddresstag!=null){
						var tpAddresstagValue = tpAddresstag.getValue();
						if(tpAddresstagValue!=null){
							var tpAddressTarget = getOrCreateElementOn(owner, "Comment", "TpAddress", "tpAddressTarget_"+communicationConnectorTarget.getName());
							setTagValue(tpAddressTarget, "tpAddress", tpAddresstagValue);
							var ltpTarget = createElementOn(flexraytpnodeTarget, "Dependency", "l_connector", "");
							ltpTarget.setDependsOn(tpAddressTarget);
						}
					}
				}
			}
		}
		catch(e){
			logger.fine("error during migrate TpChannel element : "+e);
		}
	}
}